Package org.eclipse.cdt.core.dom.ast

## Enum IASTExpression.ValueCategory

- java.lang.Object
- - java.lang.Enum<IASTExpression.ValueCategory>
  - - org.eclipse.cdt.core.dom.ast.IASTExpression.ValueCategory

All Implemented Interfaces:
  `Serializable`, `Comparable<IASTExpression.ValueCategory>`

Enclosing interface:
  IASTExpression

    public static enum IASTExpression.ValueCategory
    extends Enum<IASTExpression.ValueCategory>

Since:
  5.3

### Enum Constant Summary

Enum Constants
`LVALUE` Traditional lvalue
`PRVALUE` Pure rvalue.
`XVALUE` Expiring value as introduced by c++11.

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`boolean` `isGLValue()` A generalized lvalue is either an lvalue or an xvalue.
`boolean` `isRValue()` Both prvalues and xvalues are rvalues.
`static IASTExpression.ValueCategory` `valueOf​(String name)` Returns the enum constant of this type with the specified name.
`static IASTExpression.ValueCategory[]` `values()` Returns an array containing the constants of this enum type, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Enum Constant Detail

#### LVALUE

    public static final IASTExpression.ValueCategory LVALUE

Traditional lvalue

#### XVALUE

    public static final IASTExpression.ValueCategory XVALUE

Expiring value as introduced by c++11.

#### PRVALUE

    public static final IASTExpression.ValueCategory PRVALUE

Pure rvalue.

### Method Detail

#### values

    public static IASTExpression.ValueCategory[] values()

Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

    for (IASTExpression.ValueCategory c : IASTExpression.ValueCategory.values())
        System.out.println(c);

Returns:
  an array containing the constants of this enum type, in the order they are declared

#### valueOf

    public static IASTExpression.ValueCategory valueOf​(String name)

Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum type has no constant with the specified name
  `NullPointerException` - if the argument is null

#### isRValue

    public boolean isRValue()

Both prvalues and xvalues are rvalues.

#### isGLValue

    public boolean isGLValue()

A generalized lvalue is either an lvalue or an xvalue.